﻿namespace U2UConsult.DockOfTheBay.LinqToSpatialSample
{
    using System.Data.Linq;
    using Microsoft.SqlServer.Types;

    /// <summary>
    /// Extension Methods on System.Data.Linq.Binary
    /// </summary>
    public static class BinaryExtensions
    {
        /// <summary>
        /// Converts a Linq Binary to a SQL Server Geograpy.
        /// </summary>
        /// <remarks>Throws an Exception if the Binary contains invalid data.</remarks>
        public static SqlGeography AsGeography(this Binary binary)
        {
            if (binary == null)
            {
                return SqlGeography.Null;
            }

            SqlGeography result = new SqlGeography();

            result.Read(
                new System.IO.BinaryReader(
                    new System.IO.MemoryStream(
                        binary.ToArray())));

            return result;
        }
    }
}
