/* Create database entities */

USE [Spatial]
GO

-- View
CREATE VIEW [Europe].[vw_Countries]
AS
SELECT CountryID
      ,CountryName
      ,CONVERT(VARBINARY(MAX), Shape) AS Shape
FROM  Europe.Countries
GO

-- Scalar function
CREATE FUNCTION [Europe].[Intersects] 
(
	@Shape1 NVarchar(MAX),
	@Shape2 NVarchar(MAX)
)
RETURNS integer
AS
BEGIN
	
	DECLARE @Geo1 Geography = geography::Parse(@Shape1)
	DECLARE @Geo2 Geography = geography::Parse(@Shape2)
	
	RETURN @Geo1.STIntersects(@Geo2)

END
GO

-- Table valued function
CREATE FUNCTION [Europe].[Intersectors]
(	
	@Shape NVarchar(MAX)
)
RETURNS TABLE 
AS
RETURN 
(
	SELECT CountryID, CountryName
	FROM Europe.Countries
	WHERE Shape.STIntersects(geography::Parse(@Shape)) = 1
)
GO

