/* Sample T-SQL queries */

USE [Spatial]
GO

SELECT * 
  FROM Europe.Countries

DECLARE @belgium AS geography
SELECT @belgium = Shape 
  FROM Europe.Countries 
 WHERE CountryID = 4

/* Spatial methods */

SELECT *
  FROM Europe.Countries
 WHERE Shape.STIntersects(@belgium) = 1

SELECT CountryID
  FROM Europe.Countries
 WHERE Shape.STIntersects((SELECT Shape FROM Europe.Countries WHERE CountryID = 4)) = 1

SELECT Shape
  FROM Europe.Countries  
 WHERE (SELECT Shape 
          FROM Europe.Countries 
         WHERE CountryID = 4).STIntersects(Shape) = 1

/* Scalar function */

SELECT Europe.Intersects(@belgium.ToString(), @belgium.ToString())

DECLARE @bulgaria AS geography
SELECT @bulgaria = Shape 
  FROM Europe.Countries 
 WHERE CountryID = 6

SELECT Europe.Intersects(@belgium.ToString(), @bulgaria.ToString())

/* Table valued function */

SELECT *
  FROM Europe.Intersectors(@belgium.ToString())
  
SELECT *
  FROM Europe.Intersectors(@bulgaria.ToString())